set cachedMappingConn=nothing
mappingCounter=0

set conn=createobject("adodb.connection")
strConn="dsn=ir_system33"
l_errmsg=""
conn.open ( strConn)

sql="select * from mappings"
set rsMappings = conn.execute(sql)

do while not rsMappings.eof
	 WScript.echo  ( "         ")
	 WScript.echo  ( "Validating " & rsMappings("description") )
	 WScript.echo  ( "_______________________" )
'Examine if there are duplicate values for lookup key	
	useDsn=cStr(rsMappings("useDSN"))
	dsn=cStr(rsMappings("dsn"))
	username=cStr(rsMappings("database_username"))
	password=cStr(rsMappings("database_password"))
	database_string=cStr(rsMappings("database_string"))
	strConn=getDatabaseString(useDsn,dsn,username,password,database_string)



	'wscript.echo "Creating Connection" & strConn
	on error resume next
	Set mappingConn = CreateObject("ADODB.Connection")
	mappingConn.Mode = 1 ' 1: Read-only
	if instr(rsmappings("database_type_preset"),"DB2")>0 then
		mappingConn.commandtimeout=0
	else
		mappingConn.commandTimeout=720
	end if
	mappingConn.errors.clear
	mappingConn.Open strConn

	
	l_errMsg=getSQLErrorMessageNoStmt(mappingConn)
	if len(trim(l_errMsg))>0 then
		showErrorMessage "There was an error while connecting to your database. " & l_errMsg, true
		
	else
	
		
		sql="SELECT * FROM schematypes WHERE schema_type_id=" & rsMappings("schema_type_id")
		set rsSchemaType=conn.execute(sql)
	
		principal_mapping=rsSchemaType("principal_mapping")

	
		sql="SELECT * FROM mapping_tables WHERE mapping_id=" & rsMappings("mapping_id") & " AND table_name<>'" & _
			principal_mapping & "'"
		set rsLookups=conn.execute(sql)
		do while not rsLookups.eof
			sql="SELECT * FROM mapping_items WHERE mapping_id=" & rsMappings("mapping_id") & " AND table_name='" & _
					rsLookups("table_name") & "' AND fieldType='Key'"
			set rsKeys=conn.execute(sql)
			if not rsKeys.eof then
				key=rsKeys("custom_field")
				mapping_sql=trim(rsLookups("mapping_sql"))
				errorString=""
				
				errorInTable=false
				if rsLookups("mapping_type")="sql" and len(mapping_sql)>0 then
					lookup="(" & mapping_sql & ")"
				else
					lookup=trim(rsLookups("mapping_table"))
					'test if the key is a valid field from the table lookup
					strmsg=testForCorrectTable(mappingConn,errMsg,lookup,key,rsLookups("table_name"))
					if len(strmsg)>0 then
						errorString=errorString & strmsg
						errorInTable=true
					end if
				end if
	
				if len(lookup)>0 and not errorInTable then
						sql="SELECT " & key & ", sum(1) as theSum FROM " &  lookup & " GROUP BY " & key & " HAVING sum(1)>1"
						'wscript.echo strConn
						'wscript.echo sql
						set rsCount=mappingConn.execute(sql)
						
						'do while not rsCount.eof
						'	wscript.echo rsCount(key) 
						'	rsCount.moveNext
						'loop
						if not rsCount.eof then 
							errorString=errorString & "The mapped key %11% from the table %22% has duplicate values."
							errorString=replace(errorString, "%11%",key)
							errorString=replace(errorString, "%22%",lookup)
						end if
						set rsCount=nothing
				end if
				if len(errorString) > 0 then
					wscript.echo ( errorString)
				end if
			end if
			set rsKeys=nothing
	
			rsLookups.movenext
		loop
		set rsLookups=nothing
	end if
	rsmappings.movenext
loop
set conn=nothing
set rsMappings=nothing


function getDatabaseString(useDSN, dsn, database_username, database_password, database_string)
	if useDSN="Yes" then
		getDatabaseString="DSN="& dsn & ";UID=" & database_username & ";PWD=" & database_password & ";"
	else
		getDatabaseString=database_string

	end if
end function


function testForCorrectTable(sConn,msg,table,field,tableName)
	testForCorrectTable=""
	set l_conn=sConn
	set rsColumns =l_conn.OpenSchema(4)
	existColumn=false
	do while not rsColumns.eof
		if lcase(rsColumns("TABLE_NAME"))= lcase(table) then
			if lcase(trim(rsColumns("COLUMN_NAME")))=lcase(field) then
				existColumn=true
				exit do
			end if
		end if
		rsColumns.movenext
	loop
	set rsColumns=nothing
	if not existColumn then 
		testForCorrectTable="'%33%' is mapped to the wrong Table."
		testForCorrectTable=replace(testForCorrectTable, "%33%",tableName)
	end if
end function






function getConnection(strConn, l_errMsg)
	wscript.echo "Creating Connection" & strConn
	on error resume next
	Set conn55 = CreateObject("ADODB.Connection")
	conn55.Mode = 1 ' 1: Read-only
	if instr(database_type,"DB2")>0 then
		conn55.commandtimeout=0
	else
		conn55.commandTimeout=720
	end if
	conn55.errors.clear
	conn55.Open strConn
	l_errMsg=getSQLErrorMessageNoStmt(conn55)
	if len(trim(l_errMsg))>0 then
		showErrorMessage "There was an error while connecting to your database. " & l_errMsg, true
		
	end if
	set getConnection=conn55
	set conn55=nothing
end function

sub showErrorMessage ( l_msg , quitProgram )
	Wscript.echo (l_msg)
	wscript.quit
end sub



function getSQLErrorMessageNoStmt(l_conn3)
	getSQLErrorMessageNoStmt=""
	for each error77 in l_conn3.errors
		l_errDesc=nullfix2(error77.description)
		if not(inStr(l_errDesc, "SQLSetConnectAttr")>0 or inStr(l_errDesc,"Multiple-step operation completed with one or more errors")>0 or (error77.nativeError=249761507 and error77.SQLState="3811") or (error77.SQLState="01000")) then
			getSQLErrorMessageNoStmt=getSQLErrorMessageNoStmt & "Error: " & l_errDesc & " (" & error77.Source & ", " & error77.number & ", " & error77.nativeError & ", " & error77.SQLState & ")"
		end if
	next
	set error77=nothing
end function


Function nullFix2(inputToFix)
    nullFix2 = inputToFix
    If IsNull(inputToFix) Then
        nullFix2 = ""
    End If
End Function